unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Buttons, StdCtrls;

type
  TForm1 = class(TForm)
    Cubo1: TImage;
    Image1: TImage;
    Bevel1: TBevel;
    Cursor: TImage;
    Direita: TSpeedButton;
    Esquerda: TSpeedButton;
    Cima: TSpeedButton;
    Baixo: TSpeedButton;
    Cubo2: TImage;
    SpeedButton2: TSpeedButton;
    Cubo3: TImage;
    Cubo4: TImage;
    Cubo5: TImage;
    Label1: TLabel;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure DireitaClick(Sender: TObject);
    procedure EsquerdaClick(Sender: TObject);
    procedure CimaClick(Sender: TObject);
    procedure BaixoClick(Sender: TObject);
    procedure Cubo1Click(Sender: TObject);
    procedure Cubo2Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Cubo3Click(Sender: TObject);
    procedure Cubo4Click(Sender: TObject);
    procedure Cubo5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

var
   Blocos: array[0..9,0..9] of byte;
   PxCur,PyCur,PosL,PosC: integer;
   HFig,HTel: HBitmap;

{--- Coloca o cursor na posio PxCur,PyCur --------------}
procedure ApagaCursor;
begin
   HTel:= Form1.Image1.Canvas.Handle;
   HFig:= Form1.Cursor.Canvas.Handle;
   BitBlt(HTel,PosC,PosL,40,20,HFig,120,0,SRCAND);
   BitBlt(HTel,PosC,PosL,40,20,HFig,080,0,SRCPAINT);
end;

procedure PoeCursor;
begin
   HTel:= Form1.Image1.Canvas.Handle;
   HFig:= Form1.Cursor.Canvas.Handle;
   PosL:= PyCur * 10 + 31 - 10 + (PxCur * 10);
   PosC:= PxCur * 20 + 181 - (PyCur * 20);
   BitBlt(HTel,PosC,PosL,40,20,HFig,40,0,SRCAND);
   BitBlt(HTel,PosC,PosL,40,20,HFig,00,0,SRCPAINT);
   Form1.Image1.Repaint;
end;

{=== Executa o programa pela primeira vez ================}
procedure TForm1.FormActivate(Sender: TObject);
var
   Tmp1,Tmp2: integer;
begin
   //Zera todos os elementos da matriz
   for Tmp1:= 0 to 9 do begin
      for Tmp2:= 0 to 9 do Blocos[Tmp1,Tmp2]:= 0;
   end;
   PxCur:= 0; PyCur:= 0; PosC:= 181; PosL:= 21;
   PoeCursor;
end;

{--- Monta a contruo na TImage -------------------------}
procedure MontaMundo;
var
   Lin,Col,PosL,PosC: integer;
begin
   ApagaCursor;
   HTel:= Form1.Image1.Canvas.Handle;
   for Lin:= 0 to 9 do begin
      for Col:= 0 to 9 do begin
         if Blocos[Lin,Col] <> 0 then begin
            case Blocos[Lin,Col] of
               1: HFig:= Form1.Cubo1.Canvas.Handle;
               2: HFig:= Form1.Cubo2.Canvas.Handle;
               3: HFig:= Form1.Cubo3.Canvas.Handle;
               4: HFig:= Form1.Cubo4.Canvas.Handle;
               5: HFig:= Form1.Cubo5.Canvas.Handle;
            end;
            PosL:= Lin * 10 + 31 - 30 + (Col * 10);
            PosC:= Col * 20 + 181 - (Lin * 20);
            BitBlt(HTel,PosC,PosL,40,41,HFig,40,0,SRCAND);
            BitBlt(HTel,PosC,PosL,40,41,HFig,00,0,SRCPAINT);
         end;
      end;
   end;
   Form1.Image1.Repaint
end;

procedure TForm1.FormKeyPress(Sender: TObject; var Key: Char);
begin
   if Key = ' ' then begin
   end;
end;

procedure TForm1.DireitaClick(Sender: TObject);
begin
   inc(PxCur); if PxCur > 9 then PxCur:= 0;
   MontaMundo; PoeCursor;
end;

procedure TForm1.EsquerdaClick(Sender: TObject);
begin
   dec(PxCur); if PxCur < 0 then PxCur:= 9;
   MontaMundo; PoeCursor;
end;

procedure TForm1.CimaClick(Sender: TObject);
begin
   dec(PyCur); if PyCur < 0 then PyCur:= 9;
   MontaMundo; PoeCursor;
end;

procedure TForm1.BaixoClick(Sender: TObject);
begin
   inc(PyCur); if PyCur > 9 then PyCur:= 0;
   MontaMundo; PoeCursor;
end;


procedure TForm1.SpeedButton2Click(Sender: TObject);
begin
   Blocos[PyCur,PxCur]:= 0;
   MontaMundo; PoeCursor;
end;

procedure TForm1.Cubo1Click(Sender: TObject);
begin
   Blocos[PyCur,PxCur]:= 1;
   MontaMundo; PoeCursor;
end;

procedure TForm1.Cubo2Click(Sender: TObject);
begin
   Blocos[PyCur,PxCur]:= 2;
   MontaMundo; PoeCursor;
end;

procedure TForm1.Cubo3Click(Sender: TObject);
begin
   Blocos[PyCur,PxCur]:= 3;
   MontaMundo; PoeCursor;
end;

procedure TForm1.Cubo4Click(Sender: TObject);
begin
   Blocos[PyCur,PxCur]:= 4;
   MontaMundo; PoeCursor;
end;

procedure TForm1.Cubo5Click(Sender: TObject);
begin
   Blocos[PyCur,PxCur]:= 5;
   MontaMundo; PoeCursor;
end;

end.

